changelog shortlog graph tags branches changeset files revisions annotate raw help

Mercurial > infra / bootstrap.sh

changeset 312: d0429338ca65
parent: 4b7478f58f15
child: 7c19637786a7
author: Richard Westhaver <ellis@rwest.io>
date: Sat, 06 Jul 2024 22:35:42 -0400
permissions: -rwxr-xr-x
description: bootstrap fix
1 #!/bin/sh
2 
3 
4 main() {
5  . ./check.sh
6  if [[ -z "${INFRA_PROFILE:-}" ]]; then
7  export INFRA_PROFILE="${1:-default.sxp}"
8  else
9  export INFRA_PROFILE="${INFRA_PROFILE}"
10  fi
11  set -eu
12  download --check
13  local _arch=$(_read arch | tr -d '"')
14  local _ext=""
15  case "$_arch" in
16  *windows*)
17  _ext=".exe"
18  ;;
19  esac
20  local _url="https://packy.compiler.company/dist/${_arch}/pack"
21  local _stash
22  if ! _stash=".stash"; then
23  # Because the previous command ran in a subshell, we must manually
24  # propagate exit status.
25  exit 1
26  fi
27  # setup default directories
28  ensure mkdir -p "${_stash}/src"
29  ensure mkdir -p "${_stash}/share/lisp/fasl"
30  ensure mkdir -p "${_stash}/tmp"
31  ensure mkdir -p "${_stash}/share/store/dist"
32  ensure mkdir -p "${_stash}/bin"
33  ensure mkdir -p "${_stash}/lib"
34  ensure mkdir -p "${_stash}/include"
35 
36  cd "${_stash}"
37  local _sbcl_pack="sbcl.tar.zst"
38  # local _rocksdb_pack="rocksdb.tar.zst"
39  local _core_pack="core.tar.zst"
40  local _infra_core="infra.core"
41  # local _core_src_pack="core-source.tar.zst"
42  local _sbcl_url="${_url}/${_sbcl_pack}"
43  # local _rocksdb_url="${_url}/${_rocksdb_pack}"
44  local _core_url="${_url}/${_core_pack}"
45  local _infra_core_url="https://packy.compiler.company/dist/${_arch}/lisp/${_infra_core}"
46  # local _core_src_url="${_url}/${_core_src_pack}"
47  if [ ! -f "tmp/$_sbcl_pack" ]; then
48  ensure download "$_sbcl_url" "tmp/$_sbcl_pack" "$_arch"
49  unzstd "tmp/${_sbcl_pack}"
50  tar -C tmp -xf "tmp/sbcl.tar"
51  cd tmp/sbcl && INSTALL_ROOT=$(realpath ../..) sh install.sh && cd ../..
52  fi
53 
54  # ensure download "$_core_src_url" "$_core_src_pack" "$_arch"
55  # unzstd "${_core_src_pack}"
56  # tar -xvf "core-source.tar"
57  # mv core src/
58  # ensure download "$_rocksdb_url" "${_rocksdb_pack}" "$_arch"
59  # unzstd "${_rocksdb_pack}"
60  # tar -xvf "pack/rocksdb.tar"
61  # cp -rf rocksdb/include/* include/
62  # cp -rf rocksdb/*.so lib/
63 
64  if [ ! -f "bin/skel" ]; then
65  cd tmp
66  ensure download "$_core_url" "${_core_pack}" "$_arch"
67  unzstd "${_core_pack}"
68  tar -xf "core.tar"
69  cd ..
70  cp -rf tmp/core/bin/* bin/
71  cp -rf tmp/core/share/* share/
72  fi
73 
74  if [ ! -f "share/lisp/$_infra_core" ]; then
75  ensure download "$_infra_core_url" "share/lisp/$_infra_core" "$_arch"
76  fi
77 
78  chmod +x bin/*
79 
80  say "bootstrap complete"
81 
82  say "starting lisp..."
83  cd .. && \
84  .stash/bin/sbcl --core .stash/share/lisp/infra.core \
85  --load autogen.lisp \
86  --eval "(infra/autogen:autogen)" \
87  --non-interactive \
88  --no-userinit --no-sysinit
89 
90  say "OK"
91 }
92 
93 _read() {
94  grep ":$1" $INFRA_HOST_CONFIG | cut -d' ' -f 2-
95 }
96 
97 # Check if curl supports the --retry flag, then pass it to the curl invocation.
98 check_curl_for_retry_support() {
99  local _retry_supported=""
100  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
101  if check_help_for "notspecified" "curl" "--retry"; then
102  _retry_supported="--retry 3"
103  if check_help_for "notspecified" "curl" "--continue-at"; then
104  # "-C -" tells curl to automatically find where to resume the download when retrying.
105  _retry_supported="--retry 3 -C -"
106  fi
107  fi
108  RETVAL="$_retry_supported"
109 }
110 
111 # Return cipher suite string specified by user, otherwise return strong TLS 1.2-1.3 cipher suites
112 # if support by local tools is detected. Detection currently supports these curl backends:
113 # GnuTLS and OpenSSL (possibly also LibreSSL and BoringSSL). Return value can be empty.
114 get_ciphersuites_for_curl() {
115  if [ -n "${TLS_CIPHERSUITES-}" ]; then
116  # user specified custom cipher suites, assume they know what they're doing
117  RETVAL="$TLS_CIPHERSUITES"
118  return
119  fi
120  local _openssl_syntax="no"
121  local _gnutls_syntax="no"
122  local _backend_supported="yes"
123  if curl -V | grep -q ' OpenSSL/'; then
124  _openssl_syntax="yes"
125  elif curl -V | grep -iq ' LibreSSL/'; then
126  _openssl_syntax="yes"
127  elif curl -V | grep -iq ' BoringSSL/'; then
128  _openssl_syntax="yes"
129  elif curl -V | grep -iq ' GnuTLS/'; then
130  _gnutls_syntax="yes"
131  else
132  _backend_supported="no"
133  fi
134  local _args_supported="no"
135  if [ "$_backend_supported" = "yes" ]; then
136  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
137  if check_help_for "notspecified" "curl" "--tlsv1.2" "--ciphers" "--proto"; then
138  _args_supported="yes"
139  fi
140  fi
141  local _cs=""
142  if [ "$_args_supported" = "yes" ]; then
143  if [ "$_openssl_syntax" = "yes" ]; then
144  _cs=$(get_strong_ciphersuites_for "openssl")
145  elif [ "$_gnutls_syntax" = "yes" ]; then
146  _cs=$(get_strong_ciphersuites_for "gnutls")
147  fi
148  fi
149  RETVAL="$_cs"
150 }
151 
152 # Return cipher suite string specified by user, otherwise return strong TLS 1.2-1.3 cipher suites
153 # if support by local tools is detected. Detection currently supports these wget backends:
154 # GnuTLS and OpenSSL (possibly also LibreSSL and BoringSSL). Return value can be empty.
155 get_ciphersuites_for_wget() {
156  if [ -n "${TLS_CIPHERSUITES-}" ]; then
157  # user specified custom cipher suites, assume they know what they're doing
158  RETVAL="$TLS_CIPHERSUITES"
159  return
160  fi
161  local _cs=""
162  if wget -V | grep -q '\-DHAVE_LIBSSL'; then
163  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
164  if check_help_for "notspecified" "wget" "TLSv1_2" "--ciphers" "--https-only" "--secure-protocol"; then
165  _cs=$(get_strong_ciphersuites_for "openssl")
166  fi
167  elif wget -V | grep -q '\-DHAVE_LIBGNUTLS'; then
168  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
169  if check_help_for "notspecified" "wget" "TLSv1_2" "--ciphers" "--https-only" "--secure-protocol"; then
170  _cs=$(get_strong_ciphersuites_for "gnutls")
171  fi
172  fi
173  RETVAL="$_cs"
174 }
175 
176 check_help_for() {
177  local _arch
178  local _cmd
179  local _arg
180  _arch="$1"
181  shift
182  _cmd="$1"
183  shift
184  local _category
185  if "$_cmd" --help | grep -q 'For all options use the manual or "--help all".'; then
186  _category="all"
187  else
188  _category=""
189  fi
190 
191  case "$_arch" in
192  *darwin*)
193  if check_cmd sw_vers; then
194  case $(sw_vers -productVersion) in
195  10.*)
196  # If we're running on macOS, older than 10.13, then we always
197  # fail to find these options to force fallback
198  if [ "$(sw_vers -productVersion | cut -d. -f2)" -lt 13 ]; then
199  # Older than 10.13
200  echo "Warning: Detected macOS platform older than 10.13"
201  return 1
202  fi
203  ;;
204  11.*)
205  # We assume Big Sur will be OK for now
206  ;;
207  *)
208  # Unknown product version, warn and continue
209  echo "Warning: Detected unknown macOS major version: $(sw_vers -productVersion)"
210  echo "Warning TLS capabilities detection may fail"
211  ;;
212  esac
213  fi
214  ;;
215  esac
216  for _arg in "$@"; do
217  if ! "$_cmd" --help "$_category" | grep -q -- "$_arg"; then
218  return 1
219  fi
220  done
221  true # not strictly needed
222 }
223 
224 # Return strong TLS 1.2-1.3 cipher suites in OpenSSL or GnuTLS syntax. TLS 1.2
225 # excludes non-ECDHE and non-AEAD cipher suites. DHE is excluded due to bad
226 # DH params often found on servers (see RFC 7919). Sequence matches or is
227 # similar to Firefox 68 ESR with weak cipher suites disabled via about:config.
228 # $1 must be openssl or gnutls.
229 get_strong_ciphersuites_for() {
230  if [ "$1" = "openssl" ]; then
231  # OpenSSL is forgiving of unknown values, no problems with TLS 1.3 values on versions that don't support it yet.
232  echo "TLS_AES_128_GCM_SHA256:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_256_GCM_SHA384:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384"
233  elif [ "$1" = "gnutls" ]; then
234  # GnuTLS isn't forgiving of unknown values, so this may require a GnuTLS version that supports TLS 1.3 even if wget doesn't.
235  # Begin with SECURE128 (and higher) then remove/add to build cipher suites. Produces same 9 cipher suites as OpenSSL but in slightly different order.
236  echo "SECURE128:-VERS-SSL3.0:-VERS-TLS1.0:-VERS-TLS1.1:-VERS-DTLS-ALL:-CIPHER-ALL:-MAC-ALL:-KX-ALL:+AEAD:+ECDHE-ECDSA:+ECDHE-RSA:+AES-128-GCM:+CHACHA20-POLY1305:+AES-256-GCM"
237  fi
238 }
239 
240 # This wraps curl or wget. Try curl first, if not installed,
241 # use wget instead.
242 download() {
243  local _dld
244  local _ciphersuites
245  local _err
246  local _status
247  local _retry
248  if check_cmd curl; then
249  _dld=curl
250  elif check_cmd wget; then
251  _dld=wget
252  else
253  _dld='curl or wget' # to be used in error message of need_cmd
254  fi
255  if [ "$1" = --check ]; then
256  need_cmd "$_dld"
257  elif [ "$_dld" = curl ]; then
258  check_curl_for_retry_support
259  _retry="$RETVAL"
260  get_ciphersuites_for_curl
261  _ciphersuites="$RETVAL"
262  if [ -n "$_ciphersuites" ]; then
263  _err=$(curl $_retry --proto '=https' --tlsv1.2 --ciphers "$_ciphersuites" --silent --show-error --fail --location "$1" --output "$2" 2>&1)
264  _status=$?
265  else
266  echo "Warning: Not enforcing strong cipher suites for TLS, this is potentially less secure"
267  if ! check_help_for "$3" curl --proto --tlsv1.2; then
268  echo "Warning: Not enforcing TLS v1.2, this is potentially less secure"
269  _err=$(curl $_retry --silent --show-error --fail --location "$1" --output "$2" 2>&1)
270  _status=$?
271  else
272  _err=$(curl $_retry --proto '=https' --tlsv1.2 --silent --show-error --fail --location "$1" --output "$2" 2>&1)
273  _status=$?
274  fi
275  fi
276  if [ -n "$_err" ]; then
277  echo "$_err" >&2
278  if echo "$_err" | grep -q 404$; then
279  err "installer for platform '$3' not found, this may be unsupported"
280  fi
281  fi
282  return $_status
283  elif [ "$_dld" = wget ]; then
284  if [ "$(wget -V 2>&1|head -2|tail -1|cut -f1 -d" ")" = "BusyBox" ]; then
285  echo "Warning: using the BusyBox version of wget. Not enforcing strong cipher suites for TLS or TLS v1.2, this is potentially less secure"
286  _err=$(wget "$1" -O "$2" 2>&1)
287  _status=$?
288  else
289  get_ciphersuites_for_wget
290  _ciphersuites="$RETVAL"
291  if [ -n "$_ciphersuites" ]; then
292  _err=$(wget --https-only --secure-protocol=TLSv1_2 --ciphers "$_ciphersuites" "$1" -O "$2" 2>&1)
293  _status=$?
294  else
295  echo "Warning: Not enforcing strong cipher suites for TLS, this is potentially less secure"
296  if ! check_help_for "$3" wget --https-only --secure-protocol; then
297  echo "Warning: Not enforcing TLS v1.2, this is potentially less secure"
298  _err=$(wget "$1" -O "$2" 2>&1)
299  _status=$?
300  else
301  _err=$(wget --https-only --secure-protocol=TLSv1_2 "$1" -O "$2" 2>&1)
302  _status=$?
303  fi
304  fi
305  fi
306  if [ -n "$_err" ]; then
307  echo "$_err" >&2
308  if echo "$_err" | grep -q ' 404 Not Found$'; then
309  err "installer for platform '$3' not found, this may be unsupported"
310  fi
311  fi
312  return $_status
313  else
314  err "Unknown downloader" # should not reach here
315  fi
316 }
317 
318 main "$@" || exit 1